<template>
  <div class="product-insights-filter-item-inner" v-if="filteredGroupProperties && Object.keys(filteredGroupProperties).length > 0">
    <div class="product-insights-filter-header">
      {{ $t('Filter collection') }}
    </div>
    <div
         class="product-insights-filter-content">
      <div v-for="(group, key, index) in filteredGroupProperties"
           :key="'product-insights-filter-property-group-'+ index"
           class="product-insights-row has-cols">
        <div class="product-insights-col insights-group-name">
          <div class="product-insights-value">{{ key }}:</div>
        </div>
        <div class="product-insights-col insights-filter">
          <div v-for="(property, index) in group"
               :key="'product-insights-filter-property-'+ index"
               :title="getTranslatedProperty(property, 'name')"
               class="product-insights-value"
               @click="togglePropertyFilter(property)">
            <span>{{ getTranslatedProperty(property, 'name') }}</span>
            <SwGsIconClose class="insights-filter-remove size-xs"/>
          </div>
        </div>
      </div>

      <SwButton class="insights-search-btn color-primary"
                :title="$t('Search for products')"
                @click="openInstantListingWithFilters">
        {{ $t('Search for products') }}
      </SwButton>
    </div>
  </div>
</template>

<script lang="ts">
  import {onMounted} from "@vue/composition-api";
  import {useProductInsights} from "../../../logic/composables/widgets/useProductInsights";
  import {useInstantListing} from "../../../logic/composables/useInstantListing";
  import {getTranslatedProperty} from "@shopware-pwa/helpers";
  import {SwGsIconClose} from "../../icons";
  import SwButton from "@/components/atoms/SwButton.vue";

  export default {
    name: "InsightsFilter",
    components: {
      SwGsIconClose,
      SwButton,
    },
    props: {
      product: {
        type: [Object, Array, String],
        default: null,
      },
    },
    setup() {
      const {
        filteredGroupProperties,
        resetFilteredProperties,
        togglePropertyFilter
      } = useProductInsights();

      const {
        searchProductsByInsightsFilters,
        instantListingAccordion
      } = useInstantListing();

      const openInstantListingWithFilters = () => {
        searchProductsByInsightsFilters();
        if (instantListingAccordion.value) instantListingAccordion.value.accordionClick({'mode': 'create'});
      }

      onMounted(() => {
        resetFilteredProperties();
      })

      return {
        filteredGroupProperties,
        togglePropertyFilter,
        getTranslatedProperty,
        openInstantListingWithFilters
      }
    }
  }
</script>

<style lang="scss" scoped>
  @import "@/assets/scss/variables";

  .product-insights-filter-item-inner {
    margin-top: var(--spacer-sm);
  }

  .product-insights-filter-header {
    font-size: var(--font-size--sm);
    padding: 5px 0;
    margin-bottom: 5px;
    border-bottom: 2px solid var(--c-primary);
  }

  .product-insights-filter-content {
    font-size: var(--font-size--sm);

    &:not(.has-no-filter) {
      padding-top: 5px;
    }

    .product-insights-row {
      margin-bottom: 5px;
    }

    .product-insights-label {
      font-weight: 500;
    }

    .product-insights-value {
      color: var(--c-text) !important;
    }

    .insights-filter {
      display: flex;
      flex-wrap: wrap;

      .product-insights-value {
        display: flex;
        align-items: center;
        border-radius: 8px;
        background-color: var(--c-light);
        padding: 2px 5px !important;
        margin-right: 5px;
        margin-bottom: 5px;

        &:hover {
          cursor: pointer;
        }
      }

      .insights-filter-remove {
        margin-left: 3px;
      }
    }

    .insights-search-btn {
      width: 100%;
      margin-bottom: var(--spacer-xs);
    }

  }
</style>
